{===============================================================================
 ReportWorkshop
 ----------------------------------------------------------------------------
 Image from file field object
 ----------------------------------------------------------------------------
 Copyright (C) TRichView.com
 ==============================================================================}


unit RVReportImageFromFileFieldObject;

interface

{$I RV_Defs.inc}

uses
  SysUtils, Classes, Graphics,
  {$IFDEF RICHVIEWDEF6}
  Variants,
  {$ENDIF}
  {$IFDEF RICHVIEWDEFXE2}
  UITypes,
  {$ENDIF}

  RVTypes, RVFuncs, RVStyle,
  RVReportPlugins, RVReportDataProvider,
  RVReportValueFormat, RVReportTypes;

(*
 Include this unit in your project to implement 'imagefromfile' field type.

 Let you have a field named FIELDNAME containing file names of images.
 Use this syntax to insert these images in your report:
 {FIELDNAME imagefromfile}
 You can use format strings, the same as for normal images, for example:
 {FIELDNAME imagefromfile "width=100"}
*)


type
  TRVReportImageFromFileFieldObject = class (TRVReportCustomFieldObject)
  public
    function GetFieldType(const FieldTypeStr: TRVUnicodeString;
      InputFieldType: TRVReportFieldType; AllowBlobs: Boolean): TRVReportFieldType;
      override;
    function GetValue(const FieldTypeStr: TRVUnicodeString;
      var FormatStr: TRVUnicodeString;
      var Value: Variant; var Stream: TStream; var StyleNo: Integer;
      AllowBlobs: Boolean): Boolean;
      override;
  end;



implementation

var
  FieldObject: TRVReportImageFromFileFieldObject;

{=========================== TRVReportImageFromFileFieldObject ================}
function TRVReportImageFromFileFieldObject.GetFieldType(
  const FieldTypeStr: TRVUnicodeString; InputFieldType: TRVReportFieldType;
  AllowBlobs: Boolean): TRVReportFieldType;
begin
  if InputFieldType = rvrftText then
    if not AllowBlobs then
      Result := InputFieldType
    else
      Result := rvrftGraphic
  else
    Result := rvrftUnknown;
end;
{------------------------------------------------------------------------------}
function TRVReportImageFromFileFieldObject.GetValue(
  const FieldTypeStr: TRVUnicodeString; var FormatStr: TRVUnicodeString;
  var Value: Variant; var Stream: TStream; var StyleNo: Integer;
  AllowBlobs: Boolean): Boolean;
begin
  Result := True;
  if not AllowBlobs then
    exit;
  try
    Stream := TFileStream.Create(Value, fmOpenRead);
  except
    Stream := nil;
    Result := False;
  end;
end;

{==============================================================================}

initialization

  FieldObject := TRVReportImageFromFileFieldObject.Create;
  RVReportPluginManager.RegisterFieldObject(
    'imagefromfile', FieldObject);

finalization

  RVReportPluginManager.UnRegisterFieldObject(
    'imagefromfile', FieldObject);
  RVFreeAndNil(FieldObject);


end.
